'---------------------------------------------------------------------------
' Title           snsFileCopy
' Author          Knuth Konrad
' Prog. Lang.     PB/DLL 2.0
' Date            06.02.1998
' Purpose         VB Filecopy Replacement
' Update
' COMMAND$        None
' VB Declare      Declare Function VBFileCopy LIB "SNSFC16.DLL" _
'                          (ByVal sSource As String, ByVal sTarget _
'                          As String, ByVal hWnd As Long) _
'                          As Integer
' Version         v1.0 - 06.02.1998
'                 Initial release
'
'                 v1.1 - 16.02.1998
'                 Setting the copy's date/time stamp equal to the source
'                 date/time stamp using DOS Int &h21, Function &h57 (as
'                 it is a 16BIT DLL. In Win32 this would be replaced with
'                 a call to the GetFileTime/SetFileTime API)
'
' Copyright (c)   1998 by sounds & sins
'                 Knuth Konrad
'                 Waldschmidtstr. 11
'                 D - 60316 Frankfurt
'                 Germany
'                 Tel. +49 69 4950072
'                 CIS 100417.1336
'                 Internet sounds_sins@compuserve.com
'
'                 Released as Freeware. Use at your own risk!!
'                 You may freely distribute this package within your
'                 own programs.
'                 If you make any enhancements to this routine I for
'                 sure would like to see them!! (Read: Be so kind and
'                 mail me a copy!)
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
'*** PROGRAMM/COMPILE OPTIONEN ***

$COMPILE DLL ".\SNSFC16.DLL"
DEFINT A-Z

'---------------------------------------------------------------------------
'*** KONSTANTEN ***

%WM_KEYDOWN = &H100

'---------------------------------------------------------------------------
'*** $LINK's und $INCLUDE's ***

DECLARE FUNCTION SendMessage LIB "USER" (BYVAL hWnd AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD

'---------------------------------------------------------------------------
'*** TYPE's ***
'---------------------------------------------------------------------------
'*** VARIABELN ***
'---------------------------------------------------------------------------

FUNCTION LibMain (BYVAL hInstance AS INTEGER, _
                  BYVAL wDataSeg AS WORD, _
                  BYVAL wHeapSize AS WORD, _
                  lpszCmdLine AS ASCIIZ) EXPORT AS INTEGER

LibMain = 1   'success!

END FUNCTION   '*** function LibMain ***
'---------------------------------------------------------------------------

FUNCTION Wep (BYVAL nParameter AS INTEGER) EXPORT AS WORD

Wep = 1       'success!

END FUNCTION   '*** function Wep ***
'---------------------------------------------------------------------------

FUNCTION VBFileCopy (szSource AS ASCIIZ, szTarget AS ASCIIZ, _
   BYVAL hWnd AS LONG) EXPORT AS INTEGER
'
' VBFileCopy copies a file szSource to szTarget in much the same
' way the VB-own FileCopy does except it provides a mean to show
' how much of the job (Percent) is done. Although VBFileCopy checks
' for the existance of szSource it should be up to you to make sure
' that the sourcefile exists and isn't opened by another application.
' Same goes for szTarget. VBFileCopy will not overwrite an existing
' file!
'
' VbFileCopy returns:
' TRUE (-1) = success
' 1         = source file not found
' 2         = target file already exists
'
' VbFileCopy expects:
' szSource     -  Fully qualified path to the source file
'                 (no wildcards are allowed)
' szTarget     -  Fully qualified path to the target file
'                 (no wildcards are allowed)
' hWnd         -  Handle to the window (control) that should receive the
'                 notification (Percent). This control MUST support a
'                 Key_Down Event!!!
'                  The percentage passed to the control can be retrieved
'                  from the KeyCode value. In order to be able to
'                  distinguish between "normal" KeyCodes and percentage
'                  passed by VBFileCopy the percentage is passed as
'                  a negative number, i.e. a progress of 20% would be
'                  passed as KeyCode = -20


IF LEN(DIR$(szSource$)) <1 THEN
'Source file not found
   FUNCTION = 1
   EXIT FUNCTION
END IF

IF LEN(DIR$(szTarget$)) >1 THEN
'Target file already exists
   FUNCTION = 2
   EXIT FUNCTION
END IF

lBlocksize& = 8192
' The bigger lBlocksize the faster the copying proccess!

hSource% = FREEFILE
OPEN szSource$ FOR BINARY AS #hSource%
'OPEN szSource$ FOR BINARY ACCESS READ LOCK SHARED AS #hSource%

GetFileDate hSource%, iOrgdate%, iOrgtime%
' Get the date/time stamp of the original file

hTarget% = FREEFILE
OPEN szTarget$ FOR OUTPUT AS #hTarget%

iPercent% = 0
lFilesize& = LOF(hSource%)

IF LOF(hSource%) > lBlocksize& THEN
' Do this if the file size/remaining part is > lBlocksize&

   FOR Yy& = 1 TO LOF(hSource%) \ lBlocksize&
      GET$ #hSource%, lBlocksize&, sFileBlock$
      PRINT #hTarget%, sFileBlock$;
      iPercent% =  - ROUND((SEEK(hSource%) *100) / lFileSize&, 0)
      iRetval% = SendMessage(hWnd, %WM_KEYDOWN, iPercent%, 0&)

   NEXT Yy&

   ' copy the remaining partial block

   GET$ #hSource%, LOF(hSource%) - ((LOF(hSource%) \ lBlocksize&) _
   * lBlocksize&), sFileBlock$
   PRINT #hTarget%, sFileBlock$;
   iPercent% =  - ROUND((SEEK(hSource%) *100) / lFileSize&, 0)
   iRetval% = SendMessage(hWnd, %WM_KEYDOWN, iPercent%, 0&)

ELSE
' or do this if the file is less than lBlocksize&
   GET$ #hSource%, LOF(hSource%), sFileBlock$
   PRINT #hTarget%, sFileBlock$;
   iPercent% =  - ROUND((SEEK(hSource%) *100) / lFileSize&, 0)
   iRetval% = SendMessage(hWnd, %WM_KEYDOWN, iPercent%, 0&)

END IF

CLOSE #hSource%
CLOSE #hTarget%

hTarget% = FREEFILE
OPEN szTarget$ FOR BINARY AS #hTarget%

SetFileDate hTarget%, iOrgdate%, iOrgtime%
' Set the date/time stamp of the copy equal to the original file

CLOSE #hTarget%

FUNCTION = -1
' success

END FUNCTION   '*** function VBFileCopy ***
'---------------------------------------------------------------------------
SUB GetFileDate (BYVAL hFilenumber AS INTEGER, iFiledate AS INTEGER, iFiletime AS INTEGER)
' Retrieves a the date/time stamp of an opened file
' using DOS INT 21, Function &h57, Subfunction &h00

hDoshandle% = FILEATTR(hFilenumber%, 2)

!mov ax, &h5700         ;File date/time &h57, Get &h00
!mov bx, hDoshandle%
!xor cx, cx             ;clear CX and DX
!xor dx, dx
!int &h21
!mov iTmpdate%, dx      ;Retrieve date and time
!mov iTmptime%, cx

iFiledate% = iTmpdate%
iFileTime% = iTmptime%

END SUB     '*** sub GetFileDate ***
'---------------------------------------------------------------------------
SUB SetFileDate (BYVAL hFilenumber AS INTEGER, BYVAL iFiledate AS INTEGER, BYVAL iFiletime AS INTEGER)
' Sets an opened file's date/time stamp
' using DOS INT 21, Function &h57, Subfunction &h01

hDoshandle% = FILEATTR(hFilenumber%, 2)

!mov ax, &h5701         ;File Date/time &h57, Set &h01
!mov bx, hDoshandle%
!mov cx, iFiletime%     ;write time and date
!mov dx, iFiledate%
!int &h21

END SUB     '*** sub SetFileDate ***
'---------------------------------------------------------------------------
